diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_v_plane.c b/drivers/gpu/drm/tidss/tidss_v_plane.c
--- a/drivers/gpu/drm/tidss/tidss_v_plane.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_v_plane.c	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,276 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
+ * Author: Subhajit Paul <subhajit_paul@ti.com>
+ */
+
+/*
+ * Virtual Planes: reuse drivers/gpu/drm/tidss/tidss_plane.c
+ */
+#include <drm/drmP.h>
+#include <drm/drm_atomic.h>
+#include <drm/drm_atomic_helper.h>
+#include <drm/drm_crtc.h>
+#include <drm/drm_crtc_helper.h>
+#include "tidss_v_display.h"
+
+#define V_PLANE_MAX_FORMATS (32)
+
+struct v_plane_state {
+	struct drm_plane_state state;
+	bool need_update;
+};
+
+struct v_plane {
+	struct drm_plane base;
+	struct tidss_device *tidss;
+	unsigned int remote_id;
+	int possible_crtcs;
+	int id;
+
+	int nformats;
+	u32 formats[V_PLANE_MAX_FORMATS];
+
+	bool can_scale;
+	bool can_mod_win;
+	int fx;
+	int fy;
+	int fw;
+	int fh;
+};
+
+#define to_v_plane(x) container_of(x, struct v_plane, base)
+#define to_v_plane_state(x) container_of(x, struct v_plane_state, state)
+
+unsigned int v_plane_get_remote_id(struct drm_plane *plane)
+{
+	struct v_plane *v_plane = to_v_plane(plane);
+
+	return v_plane->remote_id;
+}
+
+bool v_plane_update_needed(struct drm_plane *plane)
+{
+	struct v_plane_state *v_state = to_v_plane_state(plane->state);
+
+	return v_state->need_update;
+}
+
+static bool v_plane_state_changed(struct drm_plane_state *old, struct drm_plane_state *new)
+{
+	if (old->crtc != new->crtc)
+		return true;
+
+	if (old->fb != new->fb)
+		return true;
+
+	if (old->crtc_x != new->crtc_x)
+		return true;
+
+	if (old->crtc_y != new->crtc_y)
+		return true;
+
+	if (old->crtc_w != new->crtc_w)
+		return true;
+
+	if (old->crtc_h != new->crtc_h)
+		return true;
+
+	if (old->src_x != new->src_x)
+		return true;
+
+	if (old->src_y != new->src_y)
+		return true;
+
+	if (old->src_w != new->src_w)
+		return true;
+
+	if (old->src_h != new->src_h)
+		return true;
+
+	return false;
+}
+
+static int v_plane_atomic_check(struct drm_plane *plane,
+				    struct drm_plane_state *state)
+{
+	struct v_plane *v_plane = to_v_plane(plane);
+	struct drm_crtc_state *crtc_state;
+	int ret;
+
+	dev_dbg(plane->dev->dev, "%s\n", __func__);
+
+	if (!state->crtc) {
+		/*
+		 * The visible field is not reset by the DRM core but only
+		 * updated by drm_plane_helper_check_state(), set it manually.
+		 */
+		state->visible = false;
+		return 0;
+	}
+
+	crtc_state = drm_atomic_get_crtc_state(state->state, state->crtc);
+	if (IS_ERR(crtc_state))
+		return PTR_ERR(crtc_state);
+
+	ret = drm_atomic_helper_check_plane_state(state, crtc_state,
+						  0,
+						  INT_MAX,
+						  true, true);
+	if (ret < 0)
+		return ret;
+
+	if (v_plane->can_scale == false && (
+				((state->src_w >> 16) != state->crtc_w) ||
+				((state->src_h >> 16) != state->crtc_h)))
+		return -EINVAL;
+
+	if (v_plane->can_mod_win == false && (
+				state->crtc_x != v_plane->fx ||
+				state->crtc_y != v_plane->fy ||
+				state->crtc_w != v_plane->fw ||
+				state->crtc_h != v_plane->fh))
+		return -EINVAL;
+
+	return 0;
+}
+
+static void v_plane_atomic_update(struct drm_plane *plane,
+				      struct drm_plane_state *old_state)
+{
+	struct drm_plane_state *plane_state = plane->state;
+	struct v_plane_state *v_state = to_v_plane_state(plane_state);
+
+	dev_dbg(plane->dev->dev, "%s\n", __func__);
+
+	v_state->need_update = v_plane_state_changed(old_state, plane_state);
+}
+
+static void v_plane_atomic_disable(struct drm_plane *plane, struct drm_plane_state *old_state)
+{
+	struct drm_plane_state *plane_state = plane->state;
+	struct v_plane_state *v_state = to_v_plane_state(plane_state);
+
+	dev_dbg(plane->dev->dev, "%s\n", __func__);
+
+	v_state->need_update = v_plane_state_changed(old_state, plane_state);
+}
+
+static const struct drm_plane_helper_funcs v_plane_helper_funcs = {
+	.atomic_check = v_plane_atomic_check,
+	.atomic_update = v_plane_atomic_update,
+	.atomic_disable = v_plane_atomic_disable,
+};
+
+static void v_plane_destroy(struct drm_plane *plane)
+{
+	struct v_plane *v_plane = to_v_plane(plane);
+
+	dev_dbg(plane->dev->dev, "%s\n", __func__);
+
+	drm_plane_cleanup(plane);
+	kfree(v_plane);
+}
+
+static struct drm_plane_state *
+v_plane_atomic_duplicate_state(struct drm_plane *plane)
+{
+	struct v_plane_state *v_state;
+	struct drm_plane_state *state;
+
+	if (WARN_ON(!plane->state))
+		return NULL;
+
+	v_state = kmalloc(sizeof(*v_state), GFP_KERNEL);
+	if (WARN_ON(!v_state))
+		return NULL;
+
+	state = &v_state->state;
+	__drm_atomic_helper_plane_duplicate_state(plane, &v_state->state);
+
+	v_state->need_update = false;
+
+	return state;
+}
+
+static void v_plane_atomic_destroy_state(struct drm_plane *plane,
+					   struct drm_plane_state *state)
+{
+	struct v_plane_state *v_state = to_v_plane_state(state);
+
+	if (WARN_ON(!state))
+		return;
+
+	__drm_atomic_helper_plane_destroy_state(state);
+
+	kfree(v_state);
+}
+
+static const struct drm_plane_funcs v_plane_funcs = {
+	.update_plane = drm_atomic_helper_update_plane,
+	.disable_plane = drm_atomic_helper_disable_plane,
+	.reset = drm_atomic_helper_plane_reset,
+	.destroy = v_plane_destroy,
+	.atomic_duplicate_state = v_plane_atomic_duplicate_state,
+	.atomic_destroy_state = v_plane_atomic_destroy_state,
+};
+
+struct drm_plane *v_plane_init(struct tidss_device *tidss,
+		int id, int crtc_bitmask,
+		enum drm_plane_type type,
+		struct rpmsg_remotedev_display_disp *vp, int index)
+{
+	struct drm_device *dev = tidss->ddev;
+	struct drm_plane *plane;
+	struct v_plane *v_plane;
+	int ret;
+	int fmt;
+	struct rpmsg_remotedev_display_pipe *vid = &vp->pipes[index];
+
+	if (vid->num_formats > V_PLANE_MAX_FORMATS)
+		return NULL;
+
+	v_plane = kzalloc(sizeof(*v_plane), GFP_KERNEL);
+	if (!v_plane)
+		return NULL;
+
+	v_plane->tidss = tidss;
+	v_plane->id = id;
+	v_plane->remote_id = vid->pipe_id;
+	v_plane->can_scale = vid->can_scale;
+	v_plane->can_mod_win = vid->can_mod_win;
+	if (!v_plane->can_mod_win) {
+		v_plane->fx = vid->fixed_win_x;
+		v_plane->fy = vid->fixed_win_y;
+		v_plane->fw = vid->fixed_win_w;
+		v_plane->fh = vid->fixed_win_h;
+	}
+	v_plane->possible_crtcs = crtc_bitmask;
+	v_plane->nformats = vid->num_formats;
+
+	for (fmt = 0; fmt < vid->num_formats; fmt++)
+		v_plane->formats[fmt] = vid->formats[fmt];
+
+	plane = &v_plane->base;
+
+	ret = drm_universal_plane_init(dev, plane, crtc_bitmask,
+				       &v_plane_funcs, v_plane->formats,
+				       v_plane->nformats, NULL, type, "plane-0x%x", id);
+	if (ret < 0)
+		goto error;
+
+	drm_plane_helper_add(plane, &v_plane_helper_funcs);
+
+	drm_plane_create_zpos_immutable_property(plane, vid->initial_zorder);
+
+	return plane;
+
+error:
+	kfree(v_plane);
+	return NULL;
+}
+
+void v_plane_fini(struct tidss_device *tidss, struct drm_plane *plane)
+{
+	v_plane_destroy(plane);
+}
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_wb.c b/drivers/gpu/drm/tidss/tidss_wb.c
--- a/drivers/gpu/drm/tidss/tidss_wb.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_wb.c	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,166 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (C) 2019 Texas Instruments Incorporated -  http://www.ti.com/
+ * Author: Benoit Parrot <bparrot@ti.com>
+ */
+
+#include <linux/module.h>
+#include <linux/init.h>
+
+#include "tidss_wb.h"
+
+unsigned int tidss_wbdebug;
+module_param(tidss_wbdebug, uint, 0644);
+MODULE_PARM_DESC(wbdebug, "activates debug info");
+
+const struct wb_fmt tidss_wb_formats[] = {
+	{
+		.fourcc		= V4L2_PIX_FMT_NV12,
+		.coplanar	= 0,
+		.depth		= {8, 4},
+	},
+	{
+		.fourcc		= V4L2_PIX_FMT_NV12M,
+		.coplanar	= 1,
+		.depth		= {8, 4},
+	},
+	{
+		.fourcc		= V4L2_PIX_FMT_YUYV,
+		.coplanar	= 0,
+		.depth		= {16, 0},
+	},
+	{
+		.fourcc		= V4L2_PIX_FMT_UYVY,
+		.coplanar	= 0,
+		.depth		= {16, 0},
+	},
+	{
+		/* "XR24", DRM_FORMAT_XRGB8888 */
+		.fourcc		= V4L2_PIX_FMT_XBGR32,
+		.coplanar	= 0,
+		.depth		= {32, 0},
+	},
+};
+
+const unsigned int tidss_num_wb_formats = ARRAY_SIZE(tidss_wb_formats);
+
+/* find our format description corresponding to the passed v4l2_format */
+const struct wb_fmt *__tidss_wb_find_format(u32 fourcc)
+{
+	const struct wb_fmt *fmt;
+	unsigned int k;
+
+	for (k = 0; k < tidss_num_wb_formats; k++) {
+		fmt = &tidss_wb_formats[k];
+		if (fmt->fourcc == fourcc)
+			return fmt;
+	}
+
+	return NULL;
+}
+
+const struct wb_fmt *tidss_wb_find_format(struct v4l2_format *f)
+{
+	return __tidss_wb_find_format(f->fmt.pix_mp.pixelformat);
+}
+
+int tidss_wb_fourcc_v4l2_to_drm(u32 fourcc)
+{
+	switch (fourcc) {
+	case V4L2_PIX_FMT_NV12:
+	case V4L2_PIX_FMT_NV12M:
+		return DRM_FORMAT_NV12;
+	case V4L2_PIX_FMT_YUYV:
+		return DRM_FORMAT_YUYV;
+	case V4L2_PIX_FMT_UYVY:
+		return DRM_FORMAT_UYVY;
+	case V4L2_PIX_FMT_XBGR32:
+		return DRM_FORMAT_XRGB8888;
+	default:
+		WARN(1, "WB: unsupported fourcc\n");
+		return 0;
+	}
+}
+
+void tidss_wb_irq(struct wb_dev *wdev, u64 irqstatus)
+{
+	const u64 mask = DSS_IRQ_DEVICE_WB_MASK;
+
+	if (!wdev)
+		return;
+
+	irqstatus &= mask;
+	if (!irqstatus)
+		return;
+
+	if (!atomic_read(&wdev->irq_enabled))
+		return;
+
+	switch (wdev->mode) {
+	case TIDSS_WB_NOT_CONFIGURED:
+		break;
+	case TIDSS_WB_MEM2MEM_OVL:
+		tidss_wbm2m_irq(wdev->m2m, irqstatus);
+		break;
+	case TIDSS_WB_MEM2MEM_MGR:
+		/* To be added */
+		break;
+	case TIDSS_WB_CAPTURE_MGR:
+		/* To be added */
+		break;
+	default:
+		WARN_ONCE(1, "WB: unknown WB mode: 0x%x\n", wdev->mode);
+		break;
+	}
+}
+
+/*
+ * The initial setup of this device instance. Note that the initial state of
+ * the driver should be complete. So the initial format, standard, timings
+ * and video input should all be initialized to some reasonable value.
+ */
+int tidss_wb_init(struct drm_device *drmdev)
+{
+	struct tidss_device *tidss = drmdev->dev_private;
+	struct wb_dev *wdev;
+	int ret = 0;
+
+	/* Allocate a new instance */
+	wdev = devm_kzalloc(drmdev->dev, sizeof(*wdev), GFP_KERNEL);
+	if (!wdev)
+		return -ENOMEM;
+
+	wdev->drm_dev = drmdev;
+
+	/* set pseudo v4l2 device name so we can use v4l2_printk */
+	strlcpy(wdev->v4l2_dev.name, WB_MODULE_NAME,
+		sizeof(wdev->v4l2_dev.name));
+
+	tidss->wdev = wdev;
+
+	mutex_init(&wdev->lock);
+
+	atomic_set(&wdev->irq_enabled, 0);
+
+	wdev->mode = TIDSS_WB_NOT_CONFIGURED;
+
+	ret = tidss_wbm2m_init(wdev);
+	if (ret) {
+		log_err(wdev, "Failed to initialize wb m2m\n");
+		return ret;
+	}
+
+	log_dbg(wdev, "WB loaded\n");
+	return 0;
+}
+
+void tidss_wb_cleanup(struct drm_device *drmdev)
+{
+	struct tidss_device *tidss = drmdev->dev_private;
+	struct wb_dev *wdev = tidss->wdev;
+
+	log_dbg(wdev, "Cleanup WB\n");
+
+	tidss_wbm2m_cleanup(wdev);
+}
+
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_wb.h b/drivers/gpu/drm/tidss/tidss_wb.h
--- a/drivers/gpu/drm/tidss/tidss_wb.h	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_wb.h	2020-06-19 21:00:31.412227715 -0400
@@ -0,0 +1,190 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ * Copyright (C) 2019 Texas Instruments Incorporated -  http://www.ti.com/
+ * Author: Benoit Parrot <bparrot@ti.com>
+ */
+
+#ifndef __TIDSS_WB_H__
+#define __TIDSS_WB_H__
+
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/mutex.h>
+#include <linux/wait.h>
+#include <linux/hrtimer.h>
+#include <drm/drmP.h>
+#include <drm/drm_atomic.h>
+#include <drm/drm_atomic_helper.h>
+#include <drm/drm_crtc.h>
+#include <drm/drm_crtc_helper.h>
+#include <drm/drm_fb_cma_helper.h>
+#include <drm/drm_fourcc.h>
+#include <drm/drm_gem_cma_helper.h>
+#include <drm/drm_plane_helper.h>
+
+#include <linux/videodev2.h>
+#include <media/v4l2-device.h>
+#include <media/v4l2-dev.h>
+#include <media/v4l2-ioctl.h>
+#include <media/v4l2-ctrls.h>
+#include <media/v4l2-event.h>
+#include <media/videobuf2-v4l2.h>
+#include <media/videobuf2-dma-contig.h>
+
+#include "tidss_dispc.h"
+#include "tidss_dispc7.h"
+#include "tidss_drv.h"
+#include "tidss_plane.h"
+
+#define WB_MODULE_NAME "tidsswb"
+#define WBM2M_MODULE_NAME "tidss-m2m"
+
+extern unsigned int tidss_wbdebug;
+
+#define log_dbg(dev, fmt, arg...)	\
+		v4l2_dbg(1, tidss_wbdebug, &dev->v4l2_dev, "%s: " fmt, \
+			 __func__, ## arg)
+#define log_err(dev, fmt, arg...)	\
+		v4l2_err(&dev->v4l2_dev, fmt, ## arg)
+#define log_info(dev, fmt, arg...)	\
+		v4l2_info(&dev->v4l2_dev, fmt, ## arg)
+
+/* minimum and maximum frame sizes */
+#define MIN_W		2
+#define MIN_H		1
+#define MAX_W		4096
+#define MAX_H		4096
+
+/* required alignments */
+#define S_ALIGN		0	/* multiple of 1 */
+#define H_ALIGN		0	/* multiple of 2 */
+
+/* used as plane indices */
+#define MAX_PLANES	2
+#define LUMA_PLANE	0
+#define CHROMA_PLANE	1
+
+enum tidss_wb_mode {
+	TIDSS_WB_NOT_CONFIGURED = 0,
+	/* mem2mem from single ovl to wb */
+	TIDSS_WB_MEM2MEM_OVL = 1,
+	/* mem2mem from N overlays via single mgr to wb */
+	TIDSS_WB_MEM2MEM_MGR = 2,
+	/* capture from single mgr to wb */
+	TIDSS_WB_CAPTURE_MGR = 3
+};
+
+enum tidss_wb_state {
+	WB_STATE_NONE = 0,
+	WB_STATE_FIRST_FRAME,
+	WB_STATE_CAPTURING,
+	WB_STATE_STOPPING,
+	WB_STATE_STOPPED,
+};
+
+/* driver info for each of the supported video formats */
+struct wb_fmt {
+	u32	fourcc;			/* standard format identifier */
+	u8	coplanar;		/* set for unpacked Luma and Chroma */
+	u8	depth[MAX_PLANES];	/* Bits per pixel per plane*/
+};
+
+extern const struct wb_fmt tidss_wb_formats[];
+extern const unsigned int tidss_num_wb_formats;
+
+struct wb_buffer {
+	struct vb2_v4l2_buffer	vb;
+	struct list_head	list;
+};
+
+/*
+ * per-queue, driver-specific private data.
+ * MEM-2-MEM: Source: V4L2_BUF_TYPE_VIDEO_OUTPUT*
+ *            Destination: V4L2_BUF_TYPE_VIDEO_CAPTURE*
+ * CAPTURE:   Destination: V4L2_BUF_TYPE_VIDEO_CAPTURE* only
+ */
+struct wb_q_data {
+	/* format info */
+	struct v4l2_format	format;
+	/* crop/compose rectangle */
+	struct v4l2_rect	c_rect;
+	/* format info */
+	const struct wb_fmt	*fmt;
+};
+
+enum {
+	Q_DATA_SRC = 0,
+	Q_DATA_DST = 1,
+};
+
+/* find our format description corresponding to the passed v4l2_format */
+const struct wb_fmt *tidss_wb_find_format(struct v4l2_format *f);
+const struct wb_fmt *__tidss_wb_find_format(u32 fourcc);
+
+struct wb_dev {
+	struct v4l2_device	v4l2_dev;
+	struct drm_device	*drm_dev;
+
+	atomic_t		irq_enabled;
+
+	/* v4l2_ioctl mutex */
+	struct mutex		lock;
+
+	enum tidss_wb_mode	mode;
+	struct wbm2m_dev	*m2m;
+};
+
+/*
+ * there is one wbm2m_dev structure in the driver.
+ */
+struct wbm2m_dev {
+	struct v4l2_device	v4l2_dev;
+	struct video_device	vfd;
+	struct v4l2_m2m_dev	*m2m_dev;
+	struct wb_dev		*dev;
+	struct drm_plane	*plane;
+
+	/* v4l2 buffers lock */
+	spinlock_t		lock;
+
+	struct vb2_alloc_ctx	*alloc_ctx;
+};
+
+/*
+ * There is one wbm2m_ctx structure for each m2m context.
+ */
+struct wbm2m_ctx {
+	struct v4l2_fh		fh;
+	struct wbm2m_dev	*dev;
+	struct v4l2_ctrl_handler hdl;
+
+	/* current frame seq */
+	unsigned int		sequence;
+	/* abort after next irq */
+	unsigned int		aborting;
+
+	/* src & dst queue data */
+	struct wb_q_data	q_data[2];
+
+	/* src & dst state data */
+	struct drm_plane_state s_state;
+	struct drm_framebuffer s_fb;
+	struct drm_gem_cma_object s_cma_gem_obj[2];
+
+	struct drm_plane_state d_state;
+	struct drm_framebuffer d_fb;
+	struct drm_gem_cma_object d_cma_gem_obj[2];
+};
+
+static inline struct wb_buffer *to_wb_buffer(struct vb2_buffer *vb2)
+{
+	return container_of(vb2, struct wb_buffer, vb.vb2_buf);
+}
+
+int tidss_wb_fourcc_v4l2_to_drm(u32 fourcc);
+
+void tidss_wbm2m_irq(struct wbm2m_dev *dev, u64 irqstatus);
+int tidss_wbm2m_init(struct wb_dev *dev);
+void tidss_wbm2m_cleanup(struct wb_dev *dev);
+
+#endif /* __TIDSS_WB_H__ */
